unit mainu;

// Copyright  2000 by Ziff-Davis, Inc.
// Written by Neil J. Rubenking

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, ToolWin, ImgList, ActnList, imFrameU,
  Buttons, ExtCtrls, AppEvnts, StdCtrls, palfrm2u, dtoolsu,
  StdActns;

type
  TMainForm = class(TForm)
    ApplicationEvents1  : TApplicationEvents;
    OpenDialog1         : TOpenDialog;
    SaveDialog1         : TSaveDialog;
    ColorDialog1        : TColorDialog;
    ilTools             : TImageList;
    ilToolsN            : TImageList;
    ilActs              : TImageList;
    ilActsN             : TImageList;
    ilImages            : TImageList;
    imgAsterisk         : TImage;
    alMain              : TActionList;
      // File actions
        amNew           : TAction;
        amOpen          : TAction;
        amSave          : TAction;
        amSaveAs        : TAction;
        amExit          : TAction;
      // Edit actions
        amCut           : TEditCut;
        amCopy          : TEditCopy;
        amPaste         : TEditPaste;
        amClear         : TAction;
        amUndo          : TAction;
        amSelAll        : TAction;
        amSelNone       : TAction;
    alTools             : TActionList;
      atPencil          : TAction;
      atChoos           : TAction;
      atMover           : TAction;
      atDropp           : TAction;
      atPaint           : TAction;
      atLinee           : TAction;
      atRectO           : TAction;
      atRectF           : TAction;
      atLipsO           : TAction;
      atLipsF           : TAction;
      atTextt           : TAction;
    alActions           : TActionList;
      aShiftLeft        : TAction;
      aShiftRite        : TAction;
      aShiftUppp        : TAction;
      aShiftDown        : TAction;
      aRotateLeft       : TAction;
      aRotateRite       : TAction;
      aMirror           : TAction;
      aFlippp           : TAction;
      aChangeColors     : TAction;
    alImages            : TActionList;
      a48_256           : TAction;
      a32_256           : TAction;
      a16_256           : TAction;
      a48_16            : TAction;
      a32_16            : TAction;
      a16_16            : TAction;
      a48_2             : TAction;
      a32_2             : TAction;
      a16_2             : TAction;
    aPrevuBack          : TAction;
    MainMenu1           : TMainMenu;
      topFile           : TMenuItem;
        mnuNew          : TMenuItem;
        mnuOpen         : TMenuItem;
        mnuSave         : TMenuItem;
        mnuSaveAs       : TMenuItem;
        mnuExit         : TMenuItem;
      topEdit           : TMenuItem;
        mnuCut          : TMenuItem;
        mnuCopy         : TMenuItem;
        mnuPaste        : TMenuItem;
        mnuClear        : TMenuItem;
        mnuUndo         : TMenuItem;
        mnuSelAll       : TMenuItem;
        mnuSelNone      : TMenuItem;
      topTools          : TMenuItem;
        mnuPencl        : TMenuItem;
        mnuChoos        : TMenuItem;
        mnuMover        : TMenuItem;
        mnuDropp        : TMenuItem;
        mnuRectO        : TMenuItem;
        mnuRectF        : TMenuItem;
        mnuLipsO        : TMenuItem;
        mnuLipsF        : TMenuItem;
        mnuPaint        : TMenuItem;
        mnuLinee        : TMenuItem;
        mnuTextt        : TMenuItem;
      topActions        : TMenuItem;
        mnuShiftLeft    : TMenuItem;
        mnuShiftRite    : TMenuItem;
        mnuShiftUppp    : TMenuItem;
        mnuShiftDown    : TMenuItem;
        mnuRotateLeft   : TMenuItem;
        mnuRotateRite   : TMenuItem;
        mnuMirror       : TMenuItem;
        mnuFlippp       : TMenuItem;
        mnuChangeColors : TMenuItem;
      topImages         : TMenuItem;
        N48x48_256      : TMenuItem;
        N32x32_256      : TMenuItem;
        N16x16_256      : TMenuItem;
        N48x48_16       : TMenuItem;
        N32x32_16       : TMenuItem;
        N16x16_16       : TMenuItem;
        N48x48_2        : TMenuItem;
        N32x32_2        : TMenuItem;
        N16x16_2        : TMenuItem;
        mnuDelImage     : TMenuItem;
          mnuDel48_256  : TMenuItem;
          mnuDel32_256  : TMenuItem;
          mnuDel16_256  : TMenuItem;
          mnuDel48_16   : TMenuItem;
          mnuDel32_16   : TMenuItem;
          mnuDel16_16   : TMenuItem;
          mnuDel48_2    : TMenuItem;
          mnuDel32_2    : TMenuItem;
          mnuDel16_2    : TMenuItem;
        mnuPrevuBack    : TMenuItem;
      topHelp           : TMenuItem;
        mnuHelp         : TMenuItem;
        mnuAbout        : TMenuItem;
    pmImages            : TPopupMenu;
      mnuImSel          : TMenuItem;
      mnuImCre          : TMenuItem;
      mnuImDes          : TMenuItem;
    tbTools             : TToolBar;
      tbPencl           : TToolButton;
      tbChoos           : TToolButton;
      tbMover           : TToolButton;
      tbDropp           : TToolButton;
      tbPaint           : TToolButton;
      tbLinee           : TToolButton;
      tbRectO           : TToolButton;
      tbRectF           : TToolButton;
      tbLipsO           : TToolButton;
      tbLipsF           : TToolButton;
      tbTextt           : TToolButton;
    tbActions           : TToolBar;
      lblSpacer         : TLabel;
      tbShiftL          : TToolButton;
      tbShiftR          : TToolButton;
      tbShiftU          : TToolButton;
      tbShiftD          : TToolButton;
      tbSep1            : TToolButton;
      tbRotL            : TToolButton;
      tbRotR            : TToolButton;
      tbMirror          : TToolButton;
      tbFlip            : TToolButton;
      tbSep2            : TToolButton;
      tbChange          : TToolButton;
    pnlImgButtons       : TPanel;
      tbImages            : TToolBar;
        tb48_256          : TToolButton;
        tb32_256          : TToolButton;
        tb16_256          : TToolButton;
        tb48_16           : TToolButton;
        tb32_16           : TToolButton;
        tb16_16           : TToolButton;
        tb48_2            : TToolButton;
        tb32_2            : TToolButton;
        tb16_2            : TToolButton;
      pnlPrevu            : TPanel;
        pbPrevu           : TPaintBox;
    pnlImages             : TPanel;
      if48_256            : TImageFrame;
      if32_256            : TImageFrame;
      if16_256            : TImageFrame;
      if48_16             : TImageFrame;
      if32_16             : TImageFrame;
      if16_16             : TImageFrame;
      if48_2              : TImageFrame;
      if32_2              : TImageFrame;
      if16_2              : TImageFrame;
    PalFrame              : TPalFrame2;
    StatusBar1            : TStatusBar;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure amNewExecute(Sender: TObject);
    procedure amOpenExecute(Sender: TObject);
    procedure amSaveAsExecute(Sender: TObject);
    procedure amSaveExecute(Sender: TObject);
    procedure amExitExecute(Sender: TObject);
    procedure amCutUpdate(Sender: TObject);
    procedure amCutExecute(Sender: TObject);
    procedure amCopyExecute(Sender: TObject);
    procedure amPasteExecute(Sender: TObject);
    procedure amClearExecute(Sender: TObject);
    procedure amUndoUpdate(Sender: TObject);
    procedure amUndoExecute(Sender: TObject);
    procedure amSelAllExecute(Sender: TObject);
    procedure amSelNoneExecute(Sender: TObject);
    procedure atMoverUpdate(Sender: TObject);
    procedure atToolExecute(Sender: TObject);
    procedure aShiftExecute(Sender: TObject);
    procedure aTransExecute(Sender: TObject);
    procedure aChangeColorsExecute(Sender: TObject);
    procedure frameBtnContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure aImClick(Sender: TObject);
    procedure aPrevuBackExecute(Sender: TObject);
    procedure mnuDelImageClick(Sender: TObject);
    procedure mnuImageDelClick(Sender: TObject);
    procedure mnuHelpClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuImSelClick(Sender: TObject);
    procedure mnuImCreClick(Sender: TObject);
    procedure mnuImDesClick(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure StatusBar1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure pbPrevuPaint(Sender: TObject);
  private
    { Private declarations }
    iniName     : String;
    IsDirty     : Boolean;
    Frames      : ARRAY[0..8] OF TImageFrame;
    WhichFrame  : Integer;
    sbParts     : ARRAY[0..2] OF Integer;
    tools       : ARRAY [1..11] OF TDrawingTool;
    ToolIdx     : Integer;
    TheFilename : String;
    TheFolder   : String;
    MyClipboardFmt    : DWORD;   // program-specific clipboard format
    CdClipboardFmt    : DWORD;   // CursorDance clipboard format
    procedure WMDropFiles(var Msg: TWMDropFiles); message
      WM_DROPFILES;
    function BlankImageCheck : Boolean;
    procedure CellDown(Sender: TObject; X, Y, Stat :Integer);
    procedure CellMove(Sender: TObject; X, Y, Stat :Integer);
    procedure CellUp(Sender: TObject;   X, Y, Stat :Integer);
    function  CheckSave: Boolean;
    procedure ColorChange(Sender : TObject);
    procedure DelAFrame(which : Integer);
    procedure FrontAFrame(which : Integer);
    procedure FreshCursor;
    procedure OpenTheFile(const S : String);
    function  NameForFile(const S: String): String;
    function  NextGood(I : Integer) : Integer;
    procedure SaveTheFile(const S: String);
    procedure SetDirty(Value: Boolean);
    procedure SetFilename(const S : String);
    procedure ToChooseIfMove;
    procedure UpdatePreview;
  public
    { Public declarations }
    procedure YesDirty(Sender : TObject);
  end;

var
  MainForm: TMainForm;

implementation

uses AboutBox, Inifiles, Clipbrd, ShellApi, allfuncs, palconsu, icoObj;

{$R *.DFM}
{$R MORERES.RES}

type
  PClippedRect    = ^TClippedRect;
  PClippedRectOld = ^TClippedRectOld;
  TClippedRectOld = packed record //CursorDance clipboard info
    Is16Color     : Boolean;
    width, height : byte;
    cells         : ARRAY[0..1023] OF SmallInt;
  end;
  TClippedRect = packed record
    ColorCode     : Byte;
    width, height : byte;
    cells         : TCellsType;
    pal           : TPalArray;
  end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  IF (ParamCount > 0) THEN
    OpenTheFile(ParamStr(1));
end;

procedure TMainForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := CheckSave;
end;

procedure TMainForm.FormCreate(Sender: TObject);
VAR
  N, I, cur : Integer;
  TB        : TBitmap; // used in filling ImageLists
begin
  iniName := ChangeFileExt(Application.ExeName, '.INI');
  Application.HelpFile := ChangeFileExt(Application.ExeName, '.HLP');
  MyClipboardFmt := RegisterClipboardFormat('PC Mag IconEdit32');
  CdClipboardFmt := RegisterClipboardFormat('PC Mag CursorDance');
  WITH TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI')) DO
  try
    theFolder := FinalSlash(ReadString('Location', 'Location',
      ExtractFileDir(Application.ExeName)));
    pnlPrevu.Color := ReadInteger('Preview', 'Color', clSilver);
  finally
    Free;
  end;
  OpenDialog1.InitialDir := theFolder;
  SetFilename('');
  DragAcceptFiles(Self.Handle, True);
  Tools[1]  := TDPencil.Create(YesDirty);
  Tools[2]  := TDChooser.Create(YesDirty);
  Tools[3]  := TDMover.Create(YesDirty);
  Tools[4]  := TDDropper.Create(YesDirty);
  Tools[5]  := TDPaintCan.Create(YesDirty);
  Tools[6]  := TDLine.Create(YesDirty);
  Tools[7]  := TDRect.Create(YesDirty);
  Tools[8]  := TDRectF.Create(YesDirty);
  Tools[9]  := TDEllipse.Create(YesDirty);
  Tools[10] := TDEllipseF.Create (YesDirty);
  Tools[11] := TDText.Create(YesDirty);
  ToolIdx   := 1;
  // Initialize sbParts array, used to give status bar panels
  // their own flyover help
  I := 0;
  FOR N := 0 TO 2 DO
    begin
      Inc(I, StatusBar1.Panels[N].Width);
      sbParts[N] := I;
    end;
  IF ShellVersionIs4_70 THEN
    begin
      tbTools.AutoSize   := True;
      tbActions.AutoSize := True;
    end
  ELSE
    begin
      tbTools.Flat     := False;
      tbActions.Flat   := False;
      tbTools.Images   := ilTools;
      tbActions.Images := ilActs;
    end;
  // It's necessary to load the image lists at run time
  // in order to support shell versions before 4.7, and to
  // avoid problems with changing color depth
  TB := TBitmap.Create;
  try
    FOR N := 40 TO 51 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilTools.Addmasked(TB, clFuchsia);
      end;
    FOR N := 52 TO 60 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilActs.Addmasked(TB, clFuchsia);
      end;
    FOR N := 70 TO 81 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilToolsN.Addmasked(TB, clFuchsia);
      end;
    FOR N := 82 TO 90 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 16, 16, lr_DefaultColor);
        ilActsN.Addmasked(TB, clFuchsia);
      end;
    FOR N := 101 TO 118 DO
      begin
        TB.Handle := LoadImage(hInstance, MakeIntResource(N),
          IMAGE_BITMAP, 73, 16, lr_DefaultColor);
        ilImages.Addmasked(TB, clAqua);
      end;
  finally
    TB.Free;
  end;
  WhichFrame := -1;
  // Initialize array for easy access to image frames
  Frames[0] := if48_256;
  Frames[1] := if32_256;
  Frames[2] := if16_256;
  Frames[3] := if48_16;
  Frames[4] := if32_16;
  Frames[5] := if16_16;
  Frames[6] := if48_2;
  Frames[7] := if32_2;
  Frames[8] := if16_2;
  // Initialize callback functions in the image frames and set their
  // dimensions and color depth
  FOR N := 0 TO 8 DO
    WITH Frames[N] DO
      begin
        Setup(CellDown, CellMove, CellUp, PalFrame);
        Dimension := (3 - (N MOD 3))* 16;
        ColorCode := N DIV 3;
      end;
  PalFrame.OnColorChange := ColorChange;
  // Initialize the drawing tool cursors. If for some reason
  // animated cursors don't load, use "dead" cursors
  FOR N := 1 TO 11 DO
    begin
      cur := AniCurFromResource(MakeIntResource(N+20));
      IF cur = 0 THEN // If it fails for some reason, use static
        cur := LoadCursor(HInstance, MakeIntResource(N));
      Screen.Cursors[N] := cur;
    end;
  aImClick(a32_256);
  SetDirty(False);
  GetPosFmIniMax(iniName, Self, True);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SetPosToIni(iniName, Self, True);
  DragAcceptFiles(Self.Handle, False);
  WITH TIniFile.Create(ChangeFileExt(Application.ExeName, '.INI')) DO
  try
    WriteString('Location', 'Location', theFolder);
    WriteInteger('Preview', 'Color', pnlPrevu.Color);
  finally
    Free;
  end;
end;

procedure TMainForm.ApplicationEvents1Hint(Sender: TObject);
begin
  StatusBar1.panels[3].Text := Application.Hint;
end;

procedure TMainForm.amNewExecute(Sender: TObject);
VAR N : Integer;
begin
  IF NOT CheckSave THEN Exit;
  SetFilename('');
  FOR N := 0 TO 8 DO
    begin
      Frames[N].ClearCells;
      WITH TCustomAction(alImages.Actions[N]) DO
        ImageIndex := (ImageIndex MOD 9) + 9;
      CASE N OF
        0,1,2 : Frames[N].PalColors := DefPal256;
        3,4,5 : Frames[N].PalColors := DefPal16;
        6,7,8 : Frames[N].PalColors := DefPal2;
      END;
    end;
  N := WhichFrame;
  aImClick(a32_256);
  IF N = WhichFrame THEN
    Frames[WhichFrame].Refresh;
  ToChooseIfMove;
  SetDirty(False);
end;

procedure TMainForm.amOpenExecute(Sender: TObject);
begin
  IF NOT CheckSave THEN Exit;
  OpenDialog1.Filename := theFilename;
  IF NOT OpenDialog1.Execute THEN Exit;
  OpenDialog1.InitialDir := '';
  OpenTheFile(OpenDialog1.Filename);
end;

procedure TMainForm.amSaveAsExecute(Sender: TObject);
begin
  SaveDialog1.Filename := theFilename;
  IF NOT SaveDialog1.Execute THEN Exit;
  IF BlankImageCheck THEN
    SaveTheFile(SaveDialog1.Filename);
end;

procedure TMainForm.amSaveExecute(Sender: TObject);
begin
  IF theFilename = '' THEN amSaveAsExecute(amSaveAs)
  ELSE IF BlankImageCheck THEN
  SaveTheFile(theFilename);
end;

procedure TMainForm.amExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.amCutUpdate(Sender: TObject);
begin
  amCut.Enabled     := NOT IsRectEmpty(Frames[WhichFrame].FocusRect);
  amCopy.Enabled    := amCut.Enabled;
  amClear.Enabled   := amCut.Enabled;
  amSelNone.Enabled := amCut.Enabled;
  amPaste.Enabled   := Clipboard.HasFormat(MyClipboardFmt) OR
    Clipboard.HasFormat(CdClipboardFmt) OR
    Clipboard.hasFormat(CF_BITMAP);
end;

procedure TMainForm.amCutExecute(Sender: TObject);
begin
  Frames[WhichFrame].FocusCellsPreClear;
  amCopyExecute(amCopy);
  amClearExecute(amClear);
end;

procedure TMainForm.amCopyExecute(Sender: TObject);
// Copy the current frame to the clipboard, both in IconEdit32's
// own format and as a bitmap
VAR
  H          : THandle;
  PCR        : PClippedRect;
  co, ro     : Integer;
  TempBitmap : TBitmap;
begin
  TempBitmap := TBitmap.Create;
  try
    H := GlobalAlloc(GMEM_MOVEABLE AND GMEM_DDESHARE,
      SizeOf(TClippedRect));
    IF H = 0 THEN Exit;
    PCR := GlobalLock(H);
    FillChar(PCR^, SizeOf(PCR^), 0);
    WITH Frames[WhichFrame] DO
      begin
        FocusCellsGet; 
        PCR^.Width        := FocusRect.Right-FocusRect.Left+1;
        PCR^.Height       := FocusRect.Bottom-FocusRect.Top+1;
        PCR^.ColorCode    := ColorCode;
        PCR^.Cells        := SelCells;
        PCR^.pal          := PalColors;
      end;
    TempBitmap.Width  := PCR^.Width;
    TempBitmap.Height := PCR^.Height;
    FOR ro := 0 TO PCR^.Height-1 DO
      FOR co := 0 TO PCR^.Width-1 DO
          TempBitmap.Canvas.Pixels[co,ro] :=
            PalFrame.Pal[PCR^.cells[co,ro]];
    GlobalUnlock(H);
    Clipboard.Open;
    Clipboard.Assign(TempBitmap);
    Clipboard.SetAsHandle(MyClipboardFmt, H);
    Clipboard.Close;
  finally
    TempBitmap.Free;
  end;
end;

procedure TMainForm.amPasteExecute(Sender: TObject);
VAR
  H                       : THandle;
  PCR                     : PClippedRect;
  TCR                     : TClippedRect;
  PCRO                    : PClippedRectOld;
  TCRO                    : TClippedRectOld;
  N, co, ro, comax, romax : Integer;
  TempBitmap              : TBitmap;

  function AdjColor(idx : Integer; ccWas, ccIs : Integer) : Integer;
  // Adjust color if frame's color depth doesn't match color depth
  // of pasted image
  begin
    Result := Idx;
    IF (ccWas = ccIs) OR (Idx > palMaxim) THEN Exit;
    CASE (ccWas*10)+ccIs OF
      01 : begin  //256 to 16
        CASE Idx OF
          0..7     : Result := Idx;
          248..255 : Result := Idx-240;
          ELSE Result := GetNearestPaletteIndex(PalFrame.palO,
            DefPal256[idx]);
        END;
      end;
      02 : begin  //256 to 2
        CASE Idx OF
          0   : Result := Idx;
          255 : Result := 1;
          ELSE Result := GetNearestPaletteIndex(PalFrame.palO,
            DefPal256[idx]);
        END;
      end;
      10 : begin  //16 to 256
        CASE Idx OF
          8..15 : Result := Idx+240;
          ELSE    Result := Idx;
        END
      end;
      12 : begin  //16 to 2
        CASE Idx OF
          0  : Result := Idx;
          15 : Result := 1;
          ELSE Result := GetNearestPaletteIndex(PalFrame.palO,
            DefPal256[idx]);
        END;
      end;
      20 : begin  //2 to 256
        CASE Idx OF
          0 : Result := Idx;
          1 : Result := 255;
          ELSE Result := GetNearestPaletteIndex(PalFrame.palO,
            DefPal256[idx]);
        END;
      end;
      21 : begin  //2 to 16
        CASE Idx OF
          0 : Result := Idx;
          1 : Result := 15;
          ELSE Result := GetNearestPaletteIndex(PalFrame.palO,
            DefPal256[idx]);
        END;
      end;
    END;
  end;

  function MyNearestIndex(T : TColorRef) : Integer;
  // In the standard palette, half the solid colors are at the
  // very end. We match them first, because otherwise the
  // GetNearestPaletteIndex will find wrong matches earlier
  // in the palette
  VAR N : Integer;
  begin
    IF Frames[WhichFrame].ColorCode <> 0 THEN // not 256
      Result := GetNearestPaletteIndex(PalFrame.palO, T)
    ELSE
      begin
        Result := -1;
        FOR N := 248 TO 255 DO
          IF T = DefPal256[N] THEN
            begin
              Result := N;
              Break;
            end;
        IF Result = -1 THEN
          Result := GetNearestPaletteIndex(PalFrame.palO, T);
      end;
  end;

begin
  WITH Frames[WhichFrame] DO FocusCellsDrop;
  IF Clipboard.HasFormat(MyClipboardFmt) THEN
    begin
      H := Clipboard.GetAsHandle(MyClipboardFmt);
      PCR := GlobalLock(H);
      Move(PCR^, TCR, SizeOf(TCR));
      GlobalUnlock(H);
      Frames[WhichFrame].FocusRect :=
        Rect(0, 0, TCR.Width-1, TCR.Height-1);
      FOR co := 0 TO TCR.Width-1 DO
        FOR ro := 0 TO TCR.Height-1 DO
          TCR.Cells[co,ro] := AdjColor(TCR.Cells[co,ro],
            TCR.ColorCode, Frames[WhichFrame].ColorCode);
      Frames[WhichFrame].SelCells := TCR.cells;
    end
  ELSE IF Clipboard.HasFormat(CdClipboardFmt) THEN
    begin
      H := Clipboard.GetAsHandle(CdClipboardFmt);
      PCRO := GlobalLock(H);
      Move(PCRO^, TCRO, SizeOf(TCRO));
      GlobalUnlock(H);
      FilLChar(TCR, SizeOf(TCR), 0);
      IF TCRO.Is16Color THEN TCR.ColorCode := 1
      ELSE TCR.ColorCode := 0;
      TCR.Width := 32;
      TCR.Height := 32;
      Frames[WhichFrame].FocusRect :=
        Rect(0, 0, TCRO.Width-1, TCRO.Height-1);
      N          := 0;
      FOR ro := 0 TO TCRO.Height-1 DO
        FOR co := 0 TO TCRO.Width-1 DO
          begin
            TCR.cells[co,ro] := AdjColor(TCRO.cells[N],
              TCR.ColorCode, Frames[WhichFrame].ColorCode);
            Inc(N);
          end;
      Frames[WhichFrame].SelCells := TCR.cells;
    end
  ELSE IF Clipboard.HasFormat(CF_BITMAP) THEN
    begin
      TempBitmap := TBitmap.Create;
      try
        TempBitmap.Assign(Clipboard);
        comax := TempBitmap.Width-1;
        romax := TempBitmap.Height-1;
        WITH Frames[WhichFrame] DO
          begin
            IF comax > Dimension-1 THEN comax := Dimension-1;
            IF romax > Dimension-1 THEN romax := Dimension-1;
            FocusRect := Rect(0, 0, comax, romax);
            WITH TempBitmap.Canvas DO
              FOR ro := 0 TO romax DO
                FOR co := 0 TO comax DO
                  TCR.Cells[co,ro] := MyNearestIndex(Pixels[co,ro]);
            SelCells := TCR.Cells;
          end;
      finally
        TempBitmap.Free;
      end;
    end
  ELSE Exit;
  Frames[WhichFrame].UndoWRect(Frames[WhichFrame].FocusRect,
    tfPaste);
  WITH topTools.Items[2] AS
    TMenuItem DO Checked := True;
  WITH tbTools.Buttons[2] AS
    TToolButton DO Down := True;
  ToolIdx := 3;
  Frames[WhichFrame].pbDraw.Cursor := ToolIdx;
  UpdatePreview;
  SetDirty(True);
end;

procedure TMainForm.amClearExecute(Sender: TObject);
begin
  WITH Frames[WhichFrame] DO
    begin
      FocusCellsClear;
      SetDirty(True);
    end;
  UpdatePreview;
end;

procedure TMainForm.amUndoUpdate(Sender: TObject);
begin
  amUndo.Enabled := Frames[WhichFrame].UndoAble;
  amUndo.Caption := Frames[WhichFrame].UndoName;
end;

procedure TMainForm.amUndoExecute(Sender: TObject);
begin
  WITH Frames[WhichFrame] DO
    IF UndoAble THEN
      begin
        UndoDoIt;
        UpdatePreview;
      end;
end;

procedure TMainForm.amSelAllExecute(Sender: TObject);
begin
  WITH Frames[WhichFrame] DO
    begin
      UndoWRect(FocusRect, tfSelect);
      FocusRect := Rect(0, 0, Dimension-1, Dimension-1);
      FocusCellsInit;
    end;
  atToolExecute(atMover);
  FreshCursor;
end;

procedure TMainForm.amSelNoneExecute(Sender: TObject);
begin
  Frames[WhichFrame].FocusRect := NoRect;
  ToChooseIfMove;
end;

procedure TMainForm.atMoverUpdate(Sender: TObject);
begin
  atMover.Enabled := NOT IsRectEmpty(Frames[WhichFrame].FocusRect);
end;

procedure TMainForm.atToolExecute(Sender: TObject);
begin
  Tools[ToolIdx].DoneUsing;
  WITH topTools.Items[(Sender AS TContainedAction).Index] AS
    TMenuItem DO Checked := True;
  WITH tbTools.Buttons[(Sender AS TContainedAction).Index] AS
    TToolButton DO Down := True;
  ToolIdx := (Sender AS TContainedAction).Index+1;
  Frames[WhichFrame].pbDraw.Cursor := ToolIdx;
  IF (ToolIdx <> 2) AND (ToolIdx <> 3) THEN
    Frames[WhichFrame].FocusRect := NoRect;
end;

procedure TMainForm.aShiftExecute(Sender: TObject);
begin
  IF ToolIdx = 2 THEN
    begin
      atToolExecute(atMover);
      FreshCursor;
    end;
  Frames[WhichFrame].ActShift((Sender AS TAction).Tag);
  UpdatePreview;
  SetDirty(True);
end;

procedure TMainForm.aTransExecute(Sender: TObject);
begin
  Frames[WhichFrame].ActTransform((Sender AS TAction).Tag);
  UpdatePreview;
  SetDirty(True);
end;

procedure TMainForm.aChangeColorsExecute(Sender: TObject);
begin
  Frames[WhichFrame].ActChangeCol;
  UpdatePreview;
  SetDirty(True);
end;

procedure TMainForm.frameBtnContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  WITH Sender AS TToolButton DO
    begin
      mnuImSel.Tag := Index;
      mnuImCre.Tag := Index;
      mnuImDes.Tag := Index;
      mnuImSel.Caption := 'Select ' + Caption + ' image';
      mnuImCre.Caption := 'Create ' + Caption + ' image';
      mnuImDes.Caption := 'Delete ' + Caption + ' image';
      IF NOT Frames[Index].ImageExists THEN
        begin
          mnuImSel.Enabled := False;
          mnuImCre.Enabled := True;
          mnuImDes.Enabled := False;
        end
      ELSE
        begin
          mnuImSel.Enabled := True;
          mnuImCre.Enabled := False;
          mnuImDes.Enabled := NextGood(Index) <> Index;
        end;
    end;
end;

procedure TMainForm.aImClick(Sender: TObject);
begin
  WITH Sender AS TAction DO
    begin
      IF WhichFrame = Tag THEN Exit;
      IF WhichFrame >= 0 THEN
        begin
          Tools[ToolIdx].DoneUsing;
          ToChooseIfMove;
          Frames[WhichFrame].FocusCellsDrop;
          Frames[WhichFrame].FocusRect := NoRect;
        end;
      WhichFrame := Tag;
      IF NOT Frames[WhichFrame].ImageExists THEN
        begin
          Frames[WhichFrame].ImageExists := True;
          ImageIndex := ImageIndex MOD 9;
          SetDirty(True);
        end;
      FrontAFrame(Tag);
      Checked := True;
    end;
end;

procedure TMainForm.aPrevuBackExecute(Sender: TObject);
begin
  WITH ColorDialog1 DO
    begin
      Color := pnlPrevu.Color;
      IF Execute THEN
        begin
          pnlPrevu.Color := Color;
          UpdatePreview;
        end;
    end;
end;

procedure TMainForm.mnuDelImageClick(Sender: TObject);
// If only one image exists, disable all; otherwise, enable delete
// for any frame whose image exists
VAR
  N, Num : Integer;
begin
  Num := 0;
  FOR N := 0 TO 8 DO
    IF Frames[N].ImageExists THEN
      Inc(Num);
  WITH Sender AS TMenuItem DO
    FOR N := 0 TO Count-1 DO
      Items[N].Enabled := (Num > 1) AND Frames[N].ImageExists;
end;

procedure TMainForm.mnuImageDelClick(Sender: TObject);
begin
  WITH Sender AS TMenuItem DO
    DelAFrame(Tag);
end;

procedure TMainForm.mnuHelpClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TMainForm.mnuAboutClick(Sender: TObject);
begin
  WITH TAboutForm.Create(Self) DO
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.mnuImSelClick(Sender: TObject);
begin
  WITH Sender AS TMenuItem DO
    begin
      IF WhichFrame = Tag THEN Exit;
      IF WhichFrame >= 0 THEN
        begin
          Tools[ToolIdx].DoneUsing;
          ToChooseIfMove;
          Frames[WhichFrame].FocusCellsDrop;
          Frames[WhichFrame].FocusRect := NoRect;
        end;
      WhichFrame := Tag;
      TCustomAction(alImages.Actions[Tag]).Checked := True;
      FrontAFrame(Tag);
    end;
end;

procedure TMainForm.mnuImCreClick(Sender: TObject);
begin
  WITH Sender AS TMenuItem DO
    begin
      IF WhichFrame = Tag THEN Exit;
      IF WhichFrame >= 0 THEN
        begin
          Tools[ToolIdx].DoneUsing;
          ToChooseIfMove;
          Frames[WhichFrame].FocusCellsDrop;
          Frames[WhichFrame].FocusRect := NoRect;
        end;
      WhichFrame := Tag;
      Frames[WhichFrame].ImageExists := True;
      WITH TCustomAction(alImages.actions[Tag]) DO
        begin
          ImageIndex := ImageIndex MOD 9;
          Checked    := True;
          FrontAFrame(Tag);
      end;
    end;
end;

procedure TMainForm.mnuImDesClick(Sender: TObject);
begin
  WITH Sender AS TMenuItem DO
    DelAFrame(Tag);
end;

procedure TMainForm.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);

  procedure PaintPanel(I : Integer);
  VAR R : TRect;
  begin
    R.Left   := Rect.Left+1;
    R.Top    := Rect.Top+1;
    R.Right  := Rect.Right-2;
    R.Bottom := Rect.Bottom - 2;
    WITH StatusBar.Canvas DO
      begin
        SelectPalette(Handle, PalFrame.PalO, FALSE);
        RealizePalette(Handle);
        CASE I OF
          0..palMaxim : begin
            Brush.Color := PalFrame.Pal[I];
            FillRect(R);
          end;
          palTrans : begin
            pen.Color := clBlue;
            MoveTo(R.Left, R.Top);
            LineTo(R.Right, R.Bottom);
          end;
          palInvrt : begin
            pen.Color := clRed;
            MoveTo(R.Left, R.Top);
            LineTo(R.Right, R.Bottom);
          end;
        end;
      end;
  end;

  procedure ShowModStatus;
  VAR R : TRect;
  begin
    StatusBar.Canvas.Brush.Color := StatusBar.Color;
    StatusBar.Canvas.FillRect(Rect);
    R := Bounds(Rect.Left+3, Rect.Top, imgAsterisk.Width,
      imgAsterisk.Height);
    IF IsDirty THEN
      StatusBar.Canvas.BrushCopy(R, imgAsterisk.Picture.Bitmap,
        Bounds(0, 0, 13, 13), clWhite);
  end;
begin
  CASE Panel.Index OF
    0 : ShowModStatus;
    1 : PaintPanel(PalFrame.fore);
    2 : PaintPanel(PalFrame.back);
  end;
end;

procedure TMainForm.StatusBar1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
// This enables hints for status bar's panels
begin
  IF X < sbParts[0] THEN
    StatusBar1.Hint := 'Asterisk here means image has been modified'
  ELSE IF X < sbParts[1] THEN
    StatusBar1.Hint := Format('Foreground color (%s)',
      [StringForColor(PalFrame.Pal, PalFrame.fore)])
  ELSE IF X < sbParts[2] THEN
    StatusBar1.Hint := Format('Background color (%s)',
      [StringForColor(PalFrame.Pal, PalFrame.back)])
  ELSE StatusBar1.Hint := '';
end;

procedure TMainForm.pbPrevuPaint(Sender: TObject);
// Paint the preview panel using the current frame's pixels
VAR X, Y, co, ro, colr : Integer;
begin
  WITH Frames[WhichFrame] DO
    begin
      X := (pbPrevu.Width - Dimension) DIV 2;
      Y := (pbPrevu.Height - Dimension) DIV 2;
    end;
  WITH pbPrevu, Canvas DO
    begin
      Brush.Color := pnlPrevu.Color;
      FillRect(BoundsRect);
      WITH Frames[WhichFrame] DO
        FOR co := 0 TO Dimension-1 DO
         FOR ro := 0 TO Dimension-1 DO
           begin
             colr := PixelCol[co,ro];
             CASE Colr OF
               palTrans : Pixels[co+x, ro+y] := pnlPrevu.Color;
               palInvrt : Pixels[co+x, ro+y] := pnlPrevu.Color
                 XOR $FFFFFF;
               ELSE       Pixels[co+x, ro+y] :=
                 PalFrame.Pal[Colr];
             END;
           end;
    end;
end;

procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
VAR buffer : ARRAY[0..MAX_PATH] OF Char;
begin
  try
    IF DragQueryFile(Msg.Drop, 0, buffer, MAX_PATH) > 0 THEN
      begin
        IF (uppercase(ExtractFileExt(StrPas(Buffer))) = '.ICO') AND
          CheckSave THEN
          OpenTheFile(StrPas(buffer));
      end;
  finally
    DragFinish(Msg.Drop);
  end;
end;

function TMainForm.BlankImageCheck: Boolean;
const
  plur0 : ARRAY[Boolean] OF String = ('', 's');
  plur1 : ARRAY[Boolean] OF String = ('is', 'are');
VAR
  N, bCount, eCount : Integer;
  blanks : ARRAY[0..8] OF Boolean;
begin
  Result := True;
  FillChar(Blanks, SizeOf(Blanks), 0);
  bCount := 0;
  eCount := 0;
  FOR N := 0 TO 8 DO
    IF Frames[N].ImageExists THEN
      begin
        Inc(eCount);
        Frames[N].FocusRect := NoRect;
        IF Frames[N].ImageBlank THEN
          begin
            Blanks[N] := True;
            Inc(bCount);
          end;
      end;
  IF bCount = eCount THEN
    begin
      Result := MessageDlg('Every image in your icon is '+
        'completely blank. Do you really want to save this '+
        'icon?', mtConfirmation,
        [mbYes, mbNo, mbHelp], 2) = idYes;
      Exit;
    END;
  IF bCount > 0 THEN
    CASE MessageDlg(Format('%d image%s out of the '+
      '%d image%s in your icon %s completely blank. Delete the '+
      'blank image%s before saving?',[bCount, plur0[bCount>1],
      eCount, plur0[eCount>1], plur1[bCount>1], plur0[bCount>1]]),
      mtConfirmation, [mbYes, mbNo, mbHelp], 1) OF
      idYes : begin
        FOR N := 0 TO 8 DO
          IF Blanks[N] THEN
            DelAFrame(N);
      end;
      idNo  :;
      ELSE Result := False;
    end;
end;

procedure TMainForm.CellDown(Sender: TObject; X, Y, Stat: Integer);
//X and Y are cell-locations. Stat is 0 for left button, 1 for right
begin
  IF (X < 0) OR (Y < 0) THEN
    StatusBar1.Panels[3].Text := ''
  ELSE
    begin
      Tools[ToolIdx].DrawStart(X, Y, PalFrame.Fore, PalFrame.Back,
        Stat=1, Sender AS TImageFrame)
    end;
end;

procedure TMainForm.CellMove(Sender: TObject; X, Y, Stat: Integer);
//X and Y are cell-locations. Stat is 1 for left button, 2 for right,
// 0 for no button down. If the 8-bit is in Stat, draggin is constrained
begin
  IF (X < 0) OR (Y < 0) THEN
    begin
      StatusBar1.Panels[3].Text := '';
    end
  ELSE
    begin
      IF Stat AND 3 = 0 THEN
        begin
          StatusBar1.Panels[3].Text := Format('(%d,%d) %s',
            [X, Y, Frames[WhichFrame].ColString(X,Y)]);
        end
      ELSE
        begin
          Tools[ToolIdx].DrawMove(X, Y, Stat AND 8 > 0);
          StatusBar1.Panels[3].Text := Tools[ToolIdx].CoordString(X,Y);
        end;
    end;
end;

procedure TMainForm.CellUp(Sender: TObject; X, Y, Stat: Integer);
//X and Y are cell-locations. Stat is 0 for normal up, 1 for cancel
// using opposite button
begin
  IF (X < 0) OR (Y < 0) THEN
    StatusBar1.Panels[3].Text := ''
  ELSE IF Stat AND 1 = 1 THEN
    Tools[ToolIdx].DrawCancel
  ELSE
    Tools[ToolIdx].DrawEnd(X, Y);
  StatusBar1.Panels[3].Text := Format('(%d,%d) %s',
    [X, Y, Frames[WhichFrame].ColString(X,Y)]);
  UpdatePreview;
end;

function TMainForm.CheckSave: Boolean;
begin
  Result := True;
  IF IsDirty THEN
    CASE MessageBox(Handle, PChar(Format('Save changes to %s?',
      [NameForFile(theFilename)])), 'IconEdit32', MB_ICONQUESTION OR
      MB_YESNOCANCEL) OF
      idYES    : amSaveExecute(amSave);
      idNO     : ;
      idCANCEL : Result := False;
    END;
end;

procedure TMainForm.ColorChange(Sender: TObject);
// Called by the palette frame when a different color is chosen
begin
  Application.ProcessMessages;
  StatusBar1.Refresh;
end;

procedure TMainForm.DelAFrame(which : Integer);
// "Delete" a frame by clearing its contents and marking it deleted
VAR NG : Integer;
begin
  WITH TCustomAction(alImages.Actions[which]) DO
    ImageIndex := (ImageIndex MOD 9) + 9;
  IF NOT Frames[Which].ImageBlank THEN
    SetDirty(True);
  Frames[which].ClearCells;
  IF which = whichFrame THEN
    begin
      NG := NextGood(Which);
      WhichFrame := NG;
      WITH TCustomAction(alImages.Actions[NG]) DO
        Checked := True;
      FrontAFrame(NG);
    end;
end;

procedure TMainForm.FrontAFrame(which : Integer);
VAR PF : TImageFrame;
begin
  tbImages.Buttons[which].Down   := True;
  topImages.Items[which].Checked := True;
  PF                             := Frames[which];
  PF.pbDraw.Cursor               := ToolIdx;
  PalFrame.SetPalValues(PF.ColorCode);
  PalFrame.Pal                   := PF.PalColors;
  PF.BringToFront;
  UpdatePreview;
end;

procedure TMainForm.FreshCursor;
// Force a redisplay of the cursor (used after programmatic change)
VAR P : TPoint;
begin
  GetCursorPos(P);
  SetCursorPos(P.X, P.Y);
end;

procedure TMainForm.OpenTheFile(const S: String);
VAR
  IDE     : IDEObject;
  N, Num  : Integer;
begin
  WITH IcoFileObj.Create DO
  try
    LoadFromFile(S);
    ValidImages;
    Num := 0;
    FOR N := 0 TO 8 DO
      begin
        Frames[N].ClearCells;
        TCustomAction(alImages[N]).ImageIndex :=
          (TCustomAction(alImages[N]).ImageIndex MOD 9) + 9;
        IDE := IDEMatching(Frames[N].Dimension,
          Frames[N].ColorCount);
        IF IDE <> nil THEN
          begin
            Frames[N].PalColors   := IDE.PaletteColors;
            Frames[N].icoCells    := IDE.icoCells;
            Frames[N].ImageExists := True;
            TCustomAction(alImages[N]).ImageIndex :=
              TCustomAction(alImages[N]).ImageIndex MOD 9;
            Inc(Num);
          end;
      end;
    IF Num = 0 THEN
      begin
        N := WhichFrame;
        aImClick(a32_256);
        IF N = WhichFrame THEN
          Frames[WhichFrame].Refresh;
      end;
  finally
    Free;
  end;
  IF NOT Frames[WhichFrame].ImageExists THEN
    begin
      WhichFrame := NextGood(WhichFrame);
      WITH TCustomAction(alImages.Actions[WhichFrame]) DO
        Checked := True;
      FrontAFrame(WhichFrame);
    end
  ELSE
    begin
      FrontAFrame(WhichFrame);
      Frames[WhichFrame].Refresh;
    end;
  SetFilename(S);
  SetDirty(False);
end;

function TMainForm.NameForFile(const S: String): String;
begin
  IF S = '' THEN Result := '(untitled)'
  ELSE Result := ExtractFileName(S);
end;

function TMainForm.NextGood(I : Integer) : Integer;
VAR N : Integer;
begin
  Result := I;
  FOR N := I + 1 TO I + 8 DO
    IF Frames[N MOD 9].ImageExists THEN
      begin
        Result := N MOD 9;
        Exit;
      end;
end;

procedure TMainForm.SaveTheFile(const S: String);
VAR N : Integer;
begin
  WITH IcoFileObj.Create DO
  try
    FOR N := 0 TO 8 DO
      IF Frames[N].ImageExists THEN
        WITH Frames[N] DO
          begin
            FocusCellsDrop;
            AddImage(Dimension, ColorCode, IcoCells, PalColors);
          end;
    SaveToFile(S);
  finally
    Free;
  end;
  SetFilename(S);
  SetDirty(False);
end;

procedure TMainForm.SetDirty(Value: Boolean);
begin
  IF Value = IsDirty THEN Exit;
  IsDirty := Value;
  StatusBar1.refresh;
end;

procedure TMainForm.SetFilename(const S : String);
begin
  theFilename := S;
  Caption := Format('IconEdit32 - %s', [NameForFile(S)]);
  IF S <> '' THEN
    theFolder := FinalSlash(ExtractFileDir(S));
end;

procedure TMainForm.ToChooseIfMove;
// IF the move tool is selected, change to the choose tool
begin
  IF ToolIdx = 3 THEN
    begin
      atToolExecute(atChoos);
      FreshCursor;
    end;
end;

procedure TMainForm.UpdatePreview;
begin
  pbPrevu.Refresh;
end;

procedure TMainForm.YesDirty(Sender : TObject);
begin
  SetDirty(True);
end;

end.
